"use strict";

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactTestRenderer = require("react-test-renderer");

var _reactTestRenderer2 = _interopRequireDefault(_reactTestRenderer);

var _Unsplash = require("./Unsplash");

var _Unsplash2 = _interopRequireDefault(_Unsplash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe("Unsplash", function () {
  it("renders without crashing", function () {
    var tree = _reactTestRenderer2.default.create(_react2.default.createElement(_Unsplash2.default, null)).toJSON();
    expect(tree).toMatchSnapshot();
  });

  it("shows a random image", function () {
    var tree = _reactTestRenderer2.default.create(_react2.default.createElement(_Unsplash2.default, { img: true })).toJSON();
    expect(tree).toMatchSnapshot();
  });

  it("shows an avatar", function () {
    var tree = _reactTestRenderer2.default.create(_react2.default.createElement(_Unsplash2.default, { width: "64", height: "64", keywords: "face", img: true })).toJSON();
    expect(tree).toMatchSnapshot();
  });

  it("shows a placeholder with image, size and random image", function () {
    var tree = _reactTestRenderer2.default.create(_react2.default.createElement(_Unsplash2.default, { width: "800", height: "200" })).toJSON();
    expect(tree).toMatchSnapshot();
  });

  it("shows a placeholder with custom size and keywords", function () {
    var tree = _reactTestRenderer2.default.create(_react2.default.createElement(_Unsplash2.default, { width: "800", height: "200", keywords: "beach, palms, sea" })).toJSON();
    expect(tree).toMatchSnapshot();
  });

  it("shows a placeholder with content inside and custom styles", function () {
    var tree = _reactTestRenderer2.default.create(_react2.default.createElement(
      _Unsplash2.default,
      { style: { lineHeight: 2 } },
      _react2.default.createElement(
        "h1",
        { style: { color: "white", textShadow: "1px 1px 2px black" } },
        "Super awesome title"
      ),
      _react2.default.createElement(
        "p",
        null,
        "With React Unsplash Wrapper is really easy to create a Hero image."
      )
    )).toJSON();
    expect(tree).toMatchSnapshot();
  });

  it("shows a placeholder that expands to its parent", function () {
    var tree = _reactTestRenderer2.default.create(_react2.default.createElement(
      "div",
      { style: { position: "relative", width: 400, height: 400 } },
      _react2.default.createElement(_Unsplash2.default, { expand: true })
    )).toJSON();
    expect(tree).toMatchSnapshot();
  });
});